_openstack_list ()
{
  local _ANS _no
  if test -n "$3"; then NFIELD="$3"; else NFIELD="Name"; fi
  #_ANS=$(openstack $_OS_CLOUD $1 list -f value c ID -c "$NFIELD" 2>/dev/null | sed 's/^\([0-9a-f-]*\) \(.*\)$/\1\n\2/')
  _ANS=$(openstack $_OS_CLOUD $1 list -f value -c ID -c "$NFIELD" 2>/dev/null | sed 's/^\([^ ]*\) \(.*\)$/\1\n\2/')
  # Debugging
  #echo "openstack $_OS_CLOUD $1 list -f value -c ID -c \"$NFIELD\":" >> _log; echo "$_ANS" >> _log
  #echo "$_ANS"
  local IFS=$'\n'
  COMPREPLY=( $(compgen -o filenames -W '$_ANS' -- "$2") )
  for _no in $(seq 0 ${#COMPREPLY[*]}); do
	if [[ "${COMPREPLY[$_no]}" == *" "* ]]; then COMPREPLY[$_no]="\"${COMPREPLY[$_no]}\""; fi
  done
}

_openstack()
{
  local cur prev words
  COMPREPLY=()
  _get_comp_words_by_ref -n : cur prev words

  # Command data:
  cmds='access acl address aggregate antiddos application as availability baremetal bgp bgpvpn ca catalog cce coe command complete compute configuration consistency console consumer container credential cts data dcs deh dms dns domain ec2 endpoint extension federation firewall flavor floating group help host hypervisor identity image implied ip keypair kms limit limits loadbalancer mapping module nat network object obs orchestration policy port project ptr quota rds recordset region registered request role router secret security server service sfc share software stack subnet tld token trust tsigkey usage user vbs versions volume vpn zone'
  cmds_access='rule token'
  cmds_access_rule='delete list show'
  cmds_access_rule_delete='-h --help'
  cmds_access_rule_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --user --user-domain'
  cmds_access_rule_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_access_token='create'
  cmds_access_token_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --consumer-key --consumer-secret --request-key --request-secret --verifier'
  cmds_acl='delete get submit user'
  cmds_acl_delete='-h --help'
  cmds_acl_get='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_acl_submit='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --user -u --project-access --no-project-access --operation-type -o'
  cmds_acl_user='add remove'
  cmds_acl_user_add='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --user -u --project-access --no-project-access --operation-type -o'
  cmds_acl_user_remove='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --user -u --project-access --no-project-access --operation-type -o'
  cmds_address='scope'
  cmds_address_scope='create delete list set show'
  cmds_address_scope_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --ip-version --project --project-domain --share --no-share'
  cmds_address_scope_delete='-h --help'
  cmds_address_scope_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --ip-version --project --project-domain --share --no-share'
  cmds_address_scope_set='-h --help --name --share --no-share'
  cmds_address_scope_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_aggregate='add create delete list remove set show unset'
  cmds_aggregate_add='host'
  cmds_aggregate_add_host='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_aggregate_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --zone --property'
  cmds_aggregate_delete='-h --help'
  cmds_aggregate_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_aggregate_remove='host'
  cmds_aggregate_remove_host='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_aggregate_set='-h --help --name --zone --property --no-property'
  cmds_aggregate_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_aggregate_unset='-h --help --property'
  cmds_antiddos='config floatip'
  cmds_antiddos_config='list'
  cmds_antiddos_config_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_antiddos_floatip='events list show stat'
  cmds_antiddos_floatip_events='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_antiddos_floatip_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --ip --status'
  cmds_antiddos_floatip_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_antiddos_floatip_stat='day week'
  cmds_antiddos_floatip_stat_day='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_antiddos_floatip_stat_week='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --start_time'
  cmds_application='credential'
  cmds_application_credential='create delete list show'
  cmds_application_credential_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --secret --role --expiration --description --unrestricted --restricted --access-rules'
  cmds_application_credential_delete='-h --help'
  cmds_application_credential_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --user --user-domain'
  cmds_application_credential_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_as='activity config group instance policy quota'
  cmds_as_activity='list'
  cmds_as_activity_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --group --start-time --end-time --limit'
  cmds_as_config='create delete list show'
  cmds_as_config_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --flavor --image-id --instance-id --disk --key --public-ip-bandwith --user-data --metadata'
  cmds_as_config_delete='-h --help'
  cmds_as_config_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --marker'
  cmds_as_config_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_as_group='create delete disable enable list show update'
  cmds_as_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --desire-instance-number --min-instance-number --max-instance-number --cool-down-time --lb-listener-id --lbaas-listener --availability-zone --network-id --security-group --router-id --audit-method --audit-time --terminate-policy --notification --delete-public-ip'
  cmds_as_group_delete='-h --help'
  cmds_as_group_disable='-h --help'
  cmds_as_group_enable='-h --help'
  cmds_as_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --limit --marker --scaling-configuration-id --status'
  cmds_as_group_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_as_group_update='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --desire-instance-number --min-instance-number --max-instance-number --cool-down-time --lb-listener-id --lbaas-listener --availability-zone --network-id --security-group --router-id --audit-method --audit-time --terminate-policy --notification --delete-public-ip'
  cmds_as_instance='batch list remove'
  cmds_as_instance_batch='-h --help --group --delete-instance'
  cmds_as_instance_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --group --life-cycle-state --health-status --limit'
  cmds_as_instance_remove='-h --help --delete-instance'
  cmds_as_policy='create delete disable enable execute list show update'
  cmds_as_policy_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --group --type --cool-down-time --alarm-id --action-operation --action-instance-number --launch-time --recurrence-type --recurrence-value --start-time --end-time'
  cmds_as_policy_delete='-h --help'
  cmds_as_policy_disable='-h --help'
  cmds_as_policy_enable='-h --help'
  cmds_as_policy_execute='-h --help'
  cmds_as_policy_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --marker --group'
  cmds_as_policy_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --group'
  cmds_as_policy_update='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --group --type --cool-down-time --alarm-id --action-operation --action-instance-number --launch-time --recurrence-type --recurrence-value --start-time --end-time'
  cmds_as_quota='list'
  cmds_as_quota_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --group'
  cmds_availability='zone'
  cmds_availability_zone='list'
  cmds_availability_zone_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --compute --network --volume --long'
  cmds_baremetal='allocation chassis conductor create deploy driver node port volume'
  cmds_baremetal_allocation='create delete list set show unset'
  cmds_baremetal_allocation_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --resource-class --trait --candidate-node --name --uuid --owner --extra --wait --node'
  cmds_baremetal_allocation_delete='-h --help'
  cmds_baremetal_allocation_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --marker --sort --node --resource-class --state --owner --long --fields'
  cmds_baremetal_allocation_set='-h --help --name --extra'
  cmds_baremetal_allocation_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --fields'
  cmds_baremetal_allocation_unset='-h --help --name --extra'
  cmds_baremetal_chassis='create delete list set show unset'
  cmds_baremetal_chassis_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --extra --uuid'
  cmds_baremetal_chassis_delete='-h --help'
  cmds_baremetal_chassis_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --fields --limit --long --marker --sort'
  cmds_baremetal_chassis_set='-h --help --description --extra'
  cmds_baremetal_chassis_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --fields'
  cmds_baremetal_chassis_unset='-h --help --description --extra'
  cmds_baremetal_conductor='list show'
  cmds_baremetal_conductor_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --marker --sort --long --fields'
  cmds_baremetal_conductor_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --fields'
  cmds_baremetal_create='-h --help'
  cmds_baremetal_deploy='template'
  cmds_baremetal_deploy_template='create delete list set show unset'
  cmds_baremetal_deploy_template_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --uuid --extra --steps'
  cmds_baremetal_deploy_template_delete='-h --help'
  cmds_baremetal_deploy_template_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --marker --sort --long --fields'
  cmds_baremetal_deploy_template_set='-h --help --name --steps --extra'
  cmds_baremetal_deploy_template_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --fields'
  cmds_baremetal_deploy_template_unset='-h --help --extra'
  cmds_baremetal_driver='list passthru property raid show'
  cmds_baremetal_driver_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --type --long'
  cmds_baremetal_driver_passthru='call list'
  cmds_baremetal_driver_passthru_call='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --arg --http-method'
  cmds_baremetal_driver_passthru_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_baremetal_driver_property='list'
  cmds_baremetal_driver_property_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_baremetal_driver_raid='property'
  cmds_baremetal_driver_raid_property='list'
  cmds_baremetal_driver_raid_property_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_baremetal_driver_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_baremetal_node='abort add adopt bios boot clean console create delete deploy inject inspect list maintenance manage passthru power provide reboot rebuild remove rescue set show trait undeploy unrescue unset validate vif'
  cmds_baremetal_node_abort='-h --help --provision-state'
  cmds_baremetal_node_add='trait'
  cmds_baremetal_node_add_trait='-h --help'
  cmds_baremetal_node_adopt='-h --help --provision-state --wait'
  cmds_baremetal_node_bios='setting'
  cmds_baremetal_node_bios_setting='list show'
  cmds_baremetal_node_bios_setting_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_baremetal_node_bios_setting_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_baremetal_node_boot='device'
  cmds_baremetal_node_boot_device='set show'
  cmds_baremetal_node_boot_device_set='-h --help --persistent'
  cmds_baremetal_node_boot_device_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --supported'
  cmds_baremetal_node_clean='-h --help --provision-state --wait --clean-steps'
  cmds_baremetal_node_console='disable enable show'
  cmds_baremetal_node_console_disable='-h --help'
  cmds_baremetal_node_console_enable='-h --help'
  cmds_baremetal_node_console_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_baremetal_node_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --chassis-uuid --driver --driver-info --property --extra --uuid --name --bios-interface --boot-interface --console-interface --deploy-interface --inspect-interface --management-interface --network-interface --power-interface --raid-interface --rescue-interface --storage-interface --vendor-interface --resource-class --conductor-group --automated-clean --owner --lessee --description'
  cmds_baremetal_node_delete='-h --help'
  cmds_baremetal_node_deploy='-h --help --provision-state --wait --config-drive'
  cmds_baremetal_node_inject='nmi'
  cmds_baremetal_node_inject_nmi='-h --help'
  cmds_baremetal_node_inspect='-h --help --provision-state --wait'
  cmds_baremetal_node_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --marker --sort --maintenance --no-maintenance --retired --no-retired --fault --associated --unassociated --provision-state --driver --resource-class --conductor-group --conductor --chassis --owner --lessee --description-contains --long --fields'
  cmds_baremetal_node_maintenance='set unset'
  cmds_baremetal_node_maintenance_set='-h --help --reason'
  cmds_baremetal_node_maintenance_unset='-h --help'
  cmds_baremetal_node_manage='-h --help --provision-state --wait'
  cmds_baremetal_node_passthru='call list'
  cmds_baremetal_node_passthru_call='-h --help --arg --http-method'
  cmds_baremetal_node_passthru_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_baremetal_node_power='off on'
  cmds_baremetal_node_power_off='-h --help --power-timeout --soft'
  cmds_baremetal_node_power_on='-h --help --power-timeout'
  cmds_baremetal_node_provide='-h --help --provision-state --wait'
  cmds_baremetal_node_reboot='-h --help --soft --power-timeout'
  cmds_baremetal_node_rebuild='-h --help --provision-state --wait --config-drive'
  cmds_baremetal_node_remove='trait'
  cmds_baremetal_node_remove_trait='-h --help --all'
  cmds_baremetal_node_rescue='-h --help --provision-state --wait --rescue-password'
  cmds_baremetal_node_set='-h --help --instance-uuid --name --chassis-uuid --driver --bios-interface --reset-bios-interface --boot-interface --reset-boot-interface --console-interface --reset-console-interface --deploy-interface --reset-deploy-interface --inspect-interface --reset-inspect-interface --management-interface --reset-management-interface --network-interface --reset-network-interface --power-interface --reset-power-interface --raid-interface --reset-raid-interface --rescue-interface --reset-rescue-interface --storage-interface --reset-storage-interface --vendor-interface --reset-vendor-interface --reset-interfaces --resource-class --conductor-group --automated-clean --protected --protected-reason --retired --retired-reason --target-raid-config --property --extra --driver-info --instance-info --owner --lessee --description'
  cmds_baremetal_node_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --instance --fields'
  cmds_baremetal_node_trait='list'
  cmds_baremetal_node_trait_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_baremetal_node_undeploy='-h --help --provision-state --wait'
  cmds_baremetal_node_unrescue='-h --help --provision-state --wait'
  cmds_baremetal_node_unset='-h --help --instance-uuid --name --resource-class --target-raid-config --property --extra --driver-info --instance-info --chassis-uuid --bios-interface --boot-interface --console-interface --deploy-interface --inspect-interface --management-interface --network-interface --power-interface --raid-interface --rescue-interface --storage-interface --vendor-interface --conductor-group --automated-clean --protected --protected-reason --retired --retired-reason --owner --lessee --description'
  cmds_baremetal_node_validate='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_baremetal_node_vif='attach detach list'
  cmds_baremetal_node_vif_attach='-h --help --vif-info'
  cmds_baremetal_node_vif_detach='-h --help'
  cmds_baremetal_node_vif_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_baremetal_port='create delete group list set show unset'
  cmds_baremetal_port_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --node --uuid --extra --local-link-connection -l --pxe-enabled --port-group --physical-network --is-smartnic'
  cmds_baremetal_port_delete='-h --help'
  cmds_baremetal_port_group='create delete list set show unset'
  cmds_baremetal_port_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --node --address --name --uuid --extra --mode --property --support-standalone-ports --unsupport-standalone-ports'
  cmds_baremetal_port_group_delete='-h --help'
  cmds_baremetal_port_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --marker --sort --address --node --long --fields'
  cmds_baremetal_port_group_set='-h --help --node --address --name --extra --mode --property --support-standalone-ports --unsupport-standalone-ports'
  cmds_baremetal_port_group_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --address --fields'
  cmds_baremetal_port_group_unset='-h --help --name --address --extra --property'
  cmds_baremetal_port_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --address --node --port-group --limit --marker --sort --long --fields'
  cmds_baremetal_port_set='-h --help --node --address --extra --port-group --local-link-connection --pxe-enabled --pxe-disabled --physical-network --is-smartnic'
  cmds_baremetal_port_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --address --fields'
  cmds_baremetal_port_unset='-h --help --extra --port-group --physical-network --is-smartnic'
  cmds_baremetal_volume='connector target'
  cmds_baremetal_volume_connector='create delete list set show unset'
  cmds_baremetal_volume_connector_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --node --type --connector-id --uuid --extra'
  cmds_baremetal_volume_connector_delete='-h --help'
  cmds_baremetal_volume_connector_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --node --limit --marker --sort --long --fields'
  cmds_baremetal_volume_connector_set='-h --help --node --type --connector-id --extra'
  cmds_baremetal_volume_connector_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --fields'
  cmds_baremetal_volume_connector_unset='-h --help --extra'
  cmds_baremetal_volume_target='create delete list set show unset'
  cmds_baremetal_volume_target_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --node --type --property --boot-index --volume-id --uuid --extra'
  cmds_baremetal_volume_target_delete='-h --help'
  cmds_baremetal_volume_target_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --node --limit --marker --sort --long --fields'
  cmds_baremetal_volume_target_set='-h --help --node --type --property --boot-index --volume-id --extra'
  cmds_baremetal_volume_target_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --fields'
  cmds_baremetal_volume_target_unset='-h --help --extra --property'
  cmds_bgp='dragent peer speaker'
  cmds_bgp_dragent='add list remove'
  cmds_bgp_dragent_add='speaker'
  cmds_bgp_dragent_add_speaker='-h --help'
  cmds_bgp_dragent_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --bgp-speaker'
  cmds_bgp_dragent_remove='speaker'
  cmds_bgp_dragent_remove_speaker='-h --help'
  cmds_bgp_peer='create delete list set show'
  cmds_bgp_peer_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --peer-ip --remote-as --auth-type --password --project --project-domain'
  cmds_bgp_peer_delete='-h --help'
  cmds_bgp_peer_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_bgp_peer_set='-h --help --name --password'
  cmds_bgp_peer_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_bgp_speaker='add advertised create delete list remove set show show_dragents'
  cmds_bgp_speaker_add='network peer'
  cmds_bgp_speaker_add_network='-h --help'
  cmds_bgp_speaker_add_peer='-h --help'
  cmds_bgp_speaker_advertised='list_routes'
  cmds_bgp_speaker_advertised_list_routes='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_bgp_speaker_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --local-as --ip-version --advertise-floating-ip-host-routes --no-advertise-floating-ip-host-routes --advertise-tenant-networks --no-advertise-tenant-networks --project --project-domain'
  cmds_bgp_speaker_delete='-h --help'
  cmds_bgp_speaker_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --agent routes'
  cmds_bgp_speaker_remove='network peer'
  cmds_bgp_speaker_remove_network='-h --help'
  cmds_bgp_speaker_remove_peer='-h --help'
  cmds_bgp_speaker_set='-h --help --name --advertise-floating-ip-host-routes --no-advertise-floating-ip-host-routes --advertise-tenant-networks --no-advertise-tenant-networks'
  cmds_bgp_speaker_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty dragents'
  cmds_bgp_speaker_show_dragents='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_bgpvpn='create delete list network port router set show unset'
  cmds_bgpvpn_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --project-domain --name --route-target --import-target --export-target --route-distinguisher --vni --local-pref --type'
  cmds_bgpvpn_delete='-h --help'
  cmds_bgpvpn_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --project --project-domain --long --property'
  cmds_bgpvpn_network='association'
  cmds_bgpvpn_network_association='create delete list show'
  cmds_bgpvpn_network_association_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --project-domain'
  cmds_bgpvpn_network_association_delete='-h --help'
  cmds_bgpvpn_network_association_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long --property'
  cmds_bgpvpn_network_association_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_bgpvpn_port='association'
  cmds_bgpvpn_port_association='create delete list set show unset'
  cmds_bgpvpn_port_association_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --project-domain --advertise-fixed-ips --no-advertise-fixed-ips --prefix-route --bgpvpn-route'
  cmds_bgpvpn_port_association_delete='-h --help'
  cmds_bgpvpn_port_association_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long --property'
  cmds_bgpvpn_port_association_set='-h --help --advertise-fixed-ips --no-advertise-fixed-ips --prefix-route --bgpvpn-route --no-prefix-route --no-bgpvpn-route'
  cmds_bgpvpn_port_association_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_bgpvpn_port_association_unset='-h --help --advertise-fixed-ips --no-advertise-fixed-ips --prefix-route --bgpvpn-route --all-prefix-routes --all-bgpvpn-routes'
  cmds_bgpvpn_router='association'
  cmds_bgpvpn_router_association='create delete list set show unset'
  cmds_bgpvpn_router_association_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --project-domain --advertise_extra_routes --no-advertise_extra_routes'
  cmds_bgpvpn_router_association_delete='-h --help'
  cmds_bgpvpn_router_association_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long --property'
  cmds_bgpvpn_router_association_set='-h --help --advertise_extra_routes --no-advertise_extra_routes'
  cmds_bgpvpn_router_association_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_bgpvpn_router_association_unset='-h --help --advertise_extra_routes --no-advertise_extra_routes'
  cmds_bgpvpn_set='-h --help --name --route-target --no-route-target --import-target --no-import-target --export-target --no-export-target --route-distinguisher --no-route-distinguisher --vni --local-pref'
  cmds_bgpvpn_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_bgpvpn_unset='-h --help --route-target --all-route-target --import-target --all-import-target --export-target --all-export-target --route-distinguisher --all-route-distinguisher --vni --local-pref'
  cmds_ca='get list'
  cmds_ca_get='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_ca_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit -l --offset -o --name -n'
  cmds_catalog='list show'
  cmds_catalog_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_catalog_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_cce='cluster'
  cmds_cce_cluster='create delete list node show'
  cmds_cce_cluster_create='-h --help --description --version --flavor --type --highway-subnet --container-net-mode --container-net-cidr --wait --wait-interval'
  cmds_cce_cluster_delete='-h --help'
  cmds_cce_cluster_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_cce_cluster_node='create delete list show'
  cmds_cce_cluster_node_create='-h --help --flavor --volume --root_volume --ssh_key --availability_zone --annotation --label --count'
  cmds_cce_cluster_node_delete='-h --help'
  cmds_cce_cluster_node_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_cce_cluster_node_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_cce_cluster_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_coe='ca cluster nodegroup quotas service stats'
  cmds_coe_ca='rotate show sign'
  cmds_coe_ca_rotate='-h --help'
  cmds_coe_ca_show='-h --help'
  cmds_coe_ca_sign='-h --help'
  cmds_coe_cluster='config create delete list resize show template update upgrade'
  cmds_coe_cluster_config='-h --help --dir --force --output-certs --use-certificate --use-keystone'
  cmds_coe_cluster_create='-h --help --cluster-template --discovery-url --docker-volume-size --labels --keypair --master-count --node-count --timeout --master-flavor --flavor --fixed-network --fixed-subnet --floating-ip-enabled --floating-ip-disabled --merge-labels'
  cmds_coe_cluster_delete='-h --help'
  cmds_coe_cluster_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --sort-key --sort-dir'
  cmds_coe_cluster_resize='-h --help --nodes-to-remove --nodegroup'
  cmds_coe_cluster_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_coe_cluster_template='create delete list show update'
  cmds_coe_cluster_template_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --coe --image --external-network --keypair --fixed-network --fixed-subnet --network-driver --volume-driver --dns-nameserver --flavor --master-flavor --docker-volume-size --docker-storage-driver --http-proxy --https-proxy --no-proxy --labels --tls-disabled --public --registry-enabled --server-type --master-lb-enabled --floating-ip-enabled --floating-ip-disabled --hidden --visible'
  cmds_coe_cluster_template_delete='-h --help'
  cmds_coe_cluster_template_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --sort-key --sort-dir --fields'
  cmds_coe_cluster_template_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_coe_cluster_template_update='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_coe_cluster_update='-h --help --rollback'
  cmds_coe_cluster_upgrade='-h --help --max-batch-size --nodegroup'
  cmds_coe_nodegroup='create delete list show update'
  cmds_coe_nodegroup_create='-h --help --docker-volume-size --labels --node-count --min-nodes --max-nodes --role --image --flavor --merge-labels'
  cmds_coe_nodegroup_delete='-h --help'
  cmds_coe_nodegroup_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --sort-key --sort-dir --role'
  cmds_coe_nodegroup_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_coe_nodegroup_update='-h --help'
  cmds_coe_quotas='create delete list show update'
  cmds_coe_quotas_create='-h --help --project-id --resource --hard-limit'
  cmds_coe_quotas_delete='-h --help --project-id --resource'
  cmds_coe_quotas_list='-h --help --marker --limit --sort-key --sort-dir --all-tenants'
  cmds_coe_quotas_show='-h --help --project-id --resource'
  cmds_coe_quotas_update='-h --help --project-id --resource --hard-limit'
  cmds_coe_service='list'
  cmds_coe_service_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_coe_stats='list'
  cmds_coe_stats_list='-h --help'
  cmds_command='list'
  cmds_command_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --group'
  cmds_complete='-h --help --name --shell'
  cmds_compute='agent service'
  cmds_compute_agent='create delete list set'
  cmds_compute_agent_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_compute_agent_delete='-h --help'
  cmds_compute_agent_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --hypervisor'
  cmds_compute_agent_set='-h --help --agent-version --url --md5hash'
  cmds_compute_service='delete list set'
  cmds_compute_service_delete='-h --help'
  cmds_compute_service_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --host --service --long'
  cmds_compute_service_set='-h --help --enable --disable --disable-reason --up --down'
  cmds_configuration='show'
  cmds_configuration_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --mask --unmask'
  cmds_consistency='group'
  cmds_consistency_group='add create delete list remove set show snapshot'
  cmds_consistency_group_add='volume'
  cmds_consistency_group_add_volume='-h --help'
  cmds_consistency_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --volume-type --consistency-group-source --consistency-group-snapshot --description --availability-zone'
  cmds_consistency_group_delete='-h --help --force'
  cmds_consistency_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --long'
  cmds_consistency_group_remove='volume'
  cmds_consistency_group_remove_volume='-h --help'
  cmds_consistency_group_set='-h --help --name --description'
  cmds_consistency_group_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_consistency_group_snapshot='create delete list show'
  cmds_consistency_group_snapshot_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --consistency-group --description'
  cmds_consistency_group_snapshot_delete='-h --help'
  cmds_consistency_group_snapshot_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --long --status --consistency-group'
  cmds_consistency_group_snapshot_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_console='log url'
  cmds_console_log='show'
  cmds_console_log_show='-h --help --lines'
  cmds_console_url='show'
  cmds_console_url_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --novnc --xvpvnc --spice --rdp --serial --mks'
  cmds_consumer='create delete list set show'
  cmds_consumer_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description'
  cmds_consumer_delete='-h --help'
  cmds_consumer_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_consumer_set='-h --help --description'
  cmds_consumer_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_container='create delete list save set show unset'
  cmds_container_create='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --public --storage-policy'
  cmds_container_delete='-h --help --recursive -r'
  cmds_container_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --prefix --marker --end-marker --limit --long --all'
  cmds_container_save='-h --help'
  cmds_container_set='-h --help --property'
  cmds_container_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_container_unset='-h --help --property'
  cmds_credential='create delete list set show'
  cmds_credential_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --type --project'
  cmds_credential_delete='-h --help'
  cmds_credential_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --user --user-domain --type'
  cmds_credential_set='-h --help --user --type --data --project'
  cmds_credential_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_cts='trace tracker'
  cmds_cts_trace='list'
  cmds_cts_trace_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --tracker --limit --next --service_type --resource_type --resource_id --resource_name --trace_name --trace_id --level --user --start_time --end_time --long'
  cmds_cts_tracker='create delete set show'
  cmds_cts_tracker_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --bucket_name --file_prefix_name --enable_smn --topic_id --operation --send_all_key --notify_user'
  cmds_cts_tracker_delete='-h --help'
  cmds_cts_tracker_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --bucket_name --file_prefix_name --enable_smn --topic_id --operation --send_all_key --notify_user --enable --disable'
  cmds_cts_tracker_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data='protection'
  cmds_data_protection='checkpoint operationlog plan protectable provider quotaclass quotas restore scheduledoperation service trigger verification'
  cmds_data_protection_checkpoint='create delete list reset show'
  cmds_data_protection_checkpoint_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --extra_info'
  cmds_data_protection_checkpoint_delete='-h --help'
  cmds_data_protection_checkpoint_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --plan_id --start_date --end_date --project_id --marker --limit --sort'
  cmds_data_protection_checkpoint_reset='state'
  cmds_data_protection_checkpoint_reset_state='-h --help --available'
  cmds_data_protection_checkpoint_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_operationlog='list show'
  cmds_data_protection_operationlog_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --status --marker --limit --sort --project'
  cmds_data_protection_operationlog_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_plan='create delete list show update'
  cmds_data_protection_plan_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --parameters-json --parameters --description'
  cmds_data_protection_plan_delete='-h --help'
  cmds_data_protection_plan_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --name --description --status --marker --limit --sort --project'
  cmds_data_protection_plan_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_plan_update='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --resources --status'
  cmds_data_protection_protectable='instance list show'
  cmds_data_protection_protectable_instance='list show'
  cmds_data_protection_protectable_instance_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --type --marker --limit --sort --parameters'
  cmds_data_protection_protectable_instance_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --parameters'
  cmds_data_protection_protectable_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_data_protection_protectable_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_provider='list show'
  cmds_data_protection_provider_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --description --marker --limit --sort'
  cmds_data_protection_provider_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_quotaclass='show update'
  cmds_data_protection_quotaclass_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_quotaclass_update='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --plans'
  cmds_data_protection_quotas='default show update'
  cmds_data_protection_quotas_default='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --tenant'
  cmds_data_protection_quotas_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --tenant --detail'
  cmds_data_protection_quotas_update='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --plans'
  cmds_data_protection_restore='create list show'
  cmds_data_protection_restore_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --restore_target --restore_username --restore_password --parameters-json --parameters'
  cmds_data_protection_restore_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --status --marker --limit --sort --project'
  cmds_data_protection_restore_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_scheduledoperation='create delete list show'
  cmds_data_protection_scheduledoperation_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_scheduledoperation_delete='-h --help'
  cmds_data_protection_scheduledoperation_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --name --operation_type --trigger_id --operation_definition --marker --limit --sort --project'
  cmds_data_protection_scheduledoperation_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_service='disable enable list'
  cmds_data_protection_service_disable='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --reason'
  cmds_data_protection_service_enable='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_service_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --host --binary'
  cmds_data_protection_trigger='create delete list show update'
  cmds_data_protection_trigger_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_trigger_delete='-h --help'
  cmds_data_protection_trigger_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --name --type --properties --marker --limit --sort --project'
  cmds_data_protection_trigger_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_data_protection_trigger_update='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --properties'
  cmds_data_protection_verification='create list show'
  cmds_data_protection_verification_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --parameters-json --parameters'
  cmds_data_protection_verification_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --status --marker --limit --sort --project'
  cmds_data_protection_verification_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_dcs='instance stat'
  cmds_dcs_instance='backup changepwd create delete extend list params restart restore set show start stop'
  cmds_dcs_instance_backup='create delete list restore'
  cmds_dcs_instance_backup_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description'
  cmds_dcs_instance_backup_delete='-h --help'
  cmds_dcs_instance_backup_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --start --from_time --to_time'
  cmds_dcs_instance_backup_restore='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --backup --description'
  cmds_dcs_instance_changepwd='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --current_password --new_password'
  cmds_dcs_instance_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --engine --engine_version --capacity --password --vpc_id --security_group_id --subnet_id --az --product_id --backup_policy --maintain_begin --maintain_end'
  cmds_dcs_instance_delete='-h --help'
  cmds_dcs_instance_extend='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --capacity'
  cmds_dcs_instance_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --start --name --status --include_failure --exact_match'
  cmds_dcs_instance_params='list show update'
  cmds_dcs_instance_params_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_dcs_instance_params_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --param'
  cmds_dcs_instance_params_update='-h --help --param'
  cmds_dcs_instance_restart='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_dcs_instance_restore='list'
  cmds_dcs_instance_restore_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --start --from_time --to_time'
  cmds_dcs_instance_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --security_group_id --backup_policy --maintain_begin --maintain_end'
  cmds_dcs_instance_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_dcs_instance_start='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_dcs_instance_stop='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_dcs_stat='list'
  cmds_dcs_stat_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_deh='host server'
  cmds_deh_host='create delete list set show type unset'
  cmds_deh_host_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --auto_placement --no-auto_placement --availability_zone --host_type --quantity'
  cmds_deh_host_delete='-h --help'
  cmds_deh_host_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --id --name --host_type --host_type_name --flavor --state --tenant --availability_zone --limit --marker --changes_since'
  cmds_deh_host_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --auto_placement --no-auto_placement --tag'
  cmds_deh_host_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_deh_host_type='list'
  cmds_deh_host_type_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_deh_host_unset='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --tag'
  cmds_deh_server='list'
  cmds_deh_server_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_dms='az group instance maintenance product queue'
  cmds_dms_az='list'
  cmds_dms_az_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_dms_group='create delete list'
  cmds_dms_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_dms_group_delete='-h --help'
  cmds_dms_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --include_deadletter'
  cmds_dms_instance='create list restart set show topic'
  cmds_dms_instance_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --engine-name --engine-version --storage --access-user --password --router --security-group --network --availability-zone --product-id --maintenance-begin --maintenance-end --enable-public-access --enable-ssl --public-bandwidth --retention-policy --storage-spec-code'
  cmds_dms_instance_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --engine-name --status --include-failure'
  cmds_dms_instance_restart='-h --help'
  cmds_dms_instance_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --security-group --maintenance-begin --maintenance-end'
  cmds_dms_instance_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_dms_instance_topic='create delete list'
  cmds_dms_instance_topic_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --partition --replication --retention-time --enable-sync-flush --enable-sync-replication'
  cmds_dms_instance_topic_delete='-h --help'
  cmds_dms_instance_topic_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_dms_maintenance='window'
  cmds_dms_maintenance_window='list'
  cmds_dms_maintenance_window_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_dms_product='list'
  cmds_dms_product_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_dms_queue='create delete list show'
  cmds_dms_queue_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --redrive_policy --max_consume_count --retention_hours'
  cmds_dms_queue_delete='-h --help'
  cmds_dms_queue_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_dms_queue_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_dns='ptr quota recordset service zone'
  cmds_dns_ptr='record'
  cmds_dns_ptr_record='list set show unset'
  cmds_dns_ptr_record_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_dns_ptr_record_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --ttl'
  cmds_dns_ptr_record_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_dns_ptr_record_unset='-h --help'
  cmds_dns_quota='list reset set'
  cmds_dns_quota_list='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id --project-id'
  cmds_dns_quota_reset='-h --help --all-projects --edit-managed --sudo-project-id --project-id'
  cmds_dns_quota_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id --project-id --api-export-size --recordset-records --zone-records --zone-recordsets --zones'
  cmds_dns_recordset='create delete list set show'
  cmds_dns_recordset_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --zone-type --name --description --type --ttl --record'
  cmds_dns_recordset_delete='-h --help --zone-type'
  cmds_dns_recordset_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --zone-type'
  cmds_dns_recordset_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --zone-type --description --ttl --record'
  cmds_dns_recordset_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --zone-type'
  cmds_dns_service='list show'
  cmds_dns_service_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --hostname --service_name --status --all-projects --edit-managed --sudo-project-id'
  cmds_dns_service_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_dns_zone='create delete list nameserver router set show'
  cmds_dns_zone_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --email --description --type --ttl --router_id --router_region'
  cmds_dns_zone_delete='-h --help'
  cmds_dns_zone_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --type'
  cmds_dns_zone_nameserver='list'
  cmds_dns_zone_nameserver_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_dns_zone_router='add remove'
  cmds_dns_zone_router_add='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --router_id --router_region'
  cmds_dns_zone_router_remove='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --router_id --router_region'
  cmds_dns_zone_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --email --description --ttl'
  cmds_dns_zone_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_domain='create delete list set show'
  cmds_domain_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --enable --disable --or-show'
  cmds_domain_delete='-h --help'
  cmds_domain_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_domain_set='-h --help --name --description --enable --disable'
  cmds_domain_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_ec2='credentials'
  cmds_ec2_credentials='create delete list show'
  cmds_ec2_credentials_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --user --user-domain --project-domain'
  cmds_ec2_credentials_delete='-h --help --user --user-domain'
  cmds_ec2_credentials_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --user --user-domain'
  cmds_ec2_credentials_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --user --user-domain'
  cmds_endpoint='add create delete group list remove set show'
  cmds_endpoint_add='project'
  cmds_endpoint_add_project='-h --help --project-domain'
  cmds_endpoint_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --region --enable --disable'
  cmds_endpoint_delete='-h --help'
  cmds_endpoint_group='add create delete list remove set show'
  cmds_endpoint_group_add='project'
  cmds_endpoint_group_add_project='-h --help --project-domain'
  cmds_endpoint_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description'
  cmds_endpoint_group_delete='-h --help'
  cmds_endpoint_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --endpointgroup --project --domain'
  cmds_endpoint_group_remove='project'
  cmds_endpoint_group_remove_project='-h --help --project-domain'
  cmds_endpoint_group_set='-h --help --name --filters --description'
  cmds_endpoint_group_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_endpoint_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --service --interface --region --endpoint --project --project-domain'
  cmds_endpoint_remove='project'
  cmds_endpoint_remove_project='-h --help --project-domain'
  cmds_endpoint_set='-h --help --region --interface --url --service --enable --disable'
  cmds_endpoint_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_extension='list show'
  cmds_extension_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --compute --identity --network --volume --long'
  cmds_extension_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_federation='domain project protocol'
  cmds_federation_domain='list'
  cmds_federation_domain_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_federation_project='list'
  cmds_federation_project_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_federation_protocol='create delete list set show'
  cmds_federation_protocol_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --identity-provider --mapping'
  cmds_federation_protocol_delete='-h --help --identity-provider'
  cmds_federation_protocol_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --identity-provider'
  cmds_federation_protocol_set='-h --help --identity-provider --mapping'
  cmds_federation_protocol_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --identity-provider'
  cmds_firewall='group'
  cmds_firewall_group='create delete list policy rule set show unset'
  cmds_firewall_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --ingress-firewall-policy --no-ingress-firewall-policy --egress-firewall-policy --no-egress-firewall-policy --share --no-share --enable --disable --project --project-domain --port --no-port'
  cmds_firewall_group_delete='-h --help'
  cmds_firewall_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_firewall_group_policy='add create delete list remove set show unset'
  cmds_firewall_group_policy_add='rule'
  cmds_firewall_group_policy_add_rule='-h --help --insert-before --insert-after'
  cmds_firewall_group_policy_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --audited --no-audited --share --no-share --project --project-domain --firewall-rule --no-firewall-rule'
  cmds_firewall_group_policy_delete='-h --help'
  cmds_firewall_group_policy_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_firewall_group_policy_remove='rule'
  cmds_firewall_group_policy_remove_rule='-h --help'
  cmds_firewall_group_policy_set='-h --help --description --audited --no-audited --share --no-share --name --firewall-rule --no-firewall-rule'
  cmds_firewall_group_policy_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_firewall_group_policy_unset='-h --help --firewall-rule --all-firewall-rule --audited --share'
  cmds_firewall_group_rule='create delete list set show unset'
  cmds_firewall_group_rule_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --protocol --action --ip-version --source-ip-address --no-source-ip-address --destination-ip-address --no-destination-ip-address --source-port --no-source-port --destination-port --no-destination-port --share --no-share --enable-rule --disable-rule --source-firewall-group --no-source-firewall-group --destination-firewall-group --no-destination-firewall-group --project --project-domain'
  cmds_firewall_group_rule_delete='-h --help'
  cmds_firewall_group_rule_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_firewall_group_rule_set='-h --help --name --description --protocol --action --ip-version --source-ip-address --no-source-ip-address --destination-ip-address --no-destination-ip-address --source-port --no-source-port --destination-port --no-destination-port --share --no-share --enable-rule --disable-rule --source-firewall-group --no-source-firewall-group --destination-firewall-group --no-destination-firewall-group'
  cmds_firewall_group_rule_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_firewall_group_rule_unset='-h --help --source-ip-address --destination-ip-address --source-port --destination-port --share --enable-rule --source-firewall-group --destination-firewall-group'
  cmds_firewall_group_set='-h --help --name --description --ingress-firewall-policy --no-ingress-firewall-policy --egress-firewall-policy --no-egress-firewall-policy --share --no-share --enable --disable --port --no-port'
  cmds_firewall_group_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_firewall_group_unset='-h --help --port --all-port --ingress-firewall-policy --egress-firewall-policy --share --enable'
  cmds_flavor='create delete list set show unset'
  cmds_flavor_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --id --ram --disk --ephemeral --swap --vcpus --rxtx-factor --public --private --property --project --description --project-domain'
  cmds_flavor_delete='-h --help'
  cmds_flavor_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --public --private --all --long --marker --limit'
  cmds_flavor_set='-h --help --no-property --property --project --description --project-domain'
  cmds_flavor_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_flavor_unset='-h --help --property --project --project-domain'
  cmds_floating='ip'
  cmds_floating_ip='create delete list pool port set show unset'
  cmds_floating_ip_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --subnet --port --floating-ip-address --fixed-ip-address --qos-policy --description --project --dns-domain --dns-name --project-domain --tag --no-tag'
  cmds_floating_ip_delete='-h --help'
  cmds_floating_ip_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --network --port --fixed-ip-address --floating-ip-address --long --status --project --project-domain --router --tags --any-tags --not-tags --not-any-tags'
  cmds_floating_ip_pool='list'
  cmds_floating_ip_pool_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_floating_ip_port='forwarding'
  cmds_floating_ip_port_forwarding='create delete list set show'
  cmds_floating_ip_port_forwarding_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --internal-ip-address --port --internal-protocol-port --external-protocol-port --protocol'
  cmds_floating_ip_port_forwarding_delete='-h --help'
  cmds_floating_ip_port_forwarding_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --port --external-protocol-port --protocol'
  cmds_floating_ip_port_forwarding_set='-h --help --port --internal-ip-address --internal-protocol-port --external-protocol-port --protocol'
  cmds_floating_ip_port_forwarding_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_floating_ip_set='-h --help --port --fixed-ip-address --description --qos-policy --no-qos-policy --tag --no-tag'
  cmds_floating_ip_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_floating_ip_unset='-h --help --port --qos-policy --tag --all-tag'
  cmds_group='add contains create delete list remove set show'
  cmds_group_add='user'
  cmds_group_add_user='-h --help --group-domain --user-domain'
  cmds_group_contains='user'
  cmds_group_contains_user='-h --help --group-domain --user-domain'
  cmds_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --domain --description --or-show'
  cmds_group_delete='-h --help --domain'
  cmds_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --domain --user --user-domain --long'
  cmds_group_remove='user'
  cmds_group_remove_user='-h --help --group-domain --user-domain'
  cmds_group_set='-h --help --domain --name --description'
  cmds_group_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --domain'
  cmds_help='-h --help'
  cmds_host='list set show'
  cmds_host_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --zone'
  cmds_host_set='-h --help --enable --disable --enable-maintenance --disable-maintenance'
  cmds_host_show='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_hypervisor='list show stats'
  cmds_hypervisor_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --matching --long'
  cmds_hypervisor_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_hypervisor_stats='show'
  cmds_hypervisor_stats_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_identity='provider'
  cmds_identity_provider='create delete list set show'
  cmds_identity_provider_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --remote-id --remote-id-file --description --domain --enable --disable'
  cmds_identity_provider_delete='-h --help'
  cmds_identity_provider_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_identity_provider_set='-h --help --description --remote-id --remote-id-file --enable --disable'
  cmds_identity_provider_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_image='add create delete list member remove save set show unset'
  cmds_image_add='project'
  cmds_image_add_project='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project-domain'
  cmds_image_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --id --container-format --disk-format --min-disk --min-ram --file --volume --force --sign-key-path --sign-cert-id --protected --unprotected --public --private --community --shared --property --tag --project --project-domain --size --location --copy-from --checksum --store'
  cmds_image_delete='-h --help'
  cmds_image_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --public --private --community --shared --property --name --status --member-status --tag --long --page-size --sort --limit --marker'
  cmds_image_member='list'
  cmds_image_member_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --project-domain'
  cmds_image_remove='project'
  cmds_image_remove_project='-h --help --project-domain'
  cmds_image_save='-h --help --file'
  cmds_image_set='-h --help --name --min-disk --min-ram --container-format --disk-format --protected --unprotected --public --private --community --shared --property --tag --architecture --instance-id --instance-uuid --kernel-id --os-distro --os-version --ramdisk-id --deactivate --activate --project --project-domain --visibility --accept --reject --pending'
  cmds_image_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --human-readable'
  cmds_image_unset='-h --help --tag --property'
  cmds_implied='role'
  cmds_implied_role='create delete list'
  cmds_implied_role_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --implied-role'
  cmds_implied_role_delete='-h --help --implied-role'
  cmds_implied_role_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_ip='availability'
  cmds_ip_availability='list show'
  cmds_ip_availability_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --ip-version --project --project-domain'
  cmds_ip_availability_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_keypair='create delete list show'
  cmds_keypair_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --public-key --private-key'
  cmds_keypair_delete='-h --help'
  cmds_keypair_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_keypair_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --public-key'
  cmds_kms='cmk'
  cmds_kms_cmk='cancel create delete disable enable list show'
  cmds_kms_cmk_cancel='delete'
  cmds_kms_cmk_cancel_delete='-h --help'
  cmds_kms_cmk_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --realm --key_policy --key_usage --type'
  cmds_kms_cmk_delete='-h --help'
  cmds_kms_cmk_disable='-h --help'
  cmds_kms_cmk_enable='-h --help'
  cmds_kms_cmk_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --state'
  cmds_kms_cmk_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_limit='create delete list set show'
  cmds_limit_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --region --project --service --resource-limit'
  cmds_limit_delete='-h --help'
  cmds_limit_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --service --resource-name --region --project'
  cmds_limit_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --resource-limit'
  cmds_limit_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_limits='show'
  cmds_limits_show='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --absolute --rate --reserved --project --domain'
  cmds_loadbalancer='amphora availabilityzone availabilityzoneprofile create delete failover flavor flavorprofile healthmonitor l7policy l7rule list listener member pool provider quota set show stats status unset'
  cmds_loadbalancer_amphora='configure failover list show stats'
  cmds_loadbalancer_amphora_configure='-h --help --wait'
  cmds_loadbalancer_amphora_failover='-h --help --wait'
  cmds_loadbalancer_amphora_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --loadbalancer --compute-id --role --status --provisioning-status --long'
  cmds_loadbalancer_amphora_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_amphora_stats='show'
  cmds_loadbalancer_amphora_stats_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --listener'
  cmds_loadbalancer_availabilityzone='create delete list set show unset'
  cmds_loadbalancer_availabilityzone_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --availabilityzoneprofile --description --enable --disable'
  cmds_loadbalancer_availabilityzone_delete='-h --help'
  cmds_loadbalancer_availabilityzone_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --availabilityzoneprofile --enable --disable'
  cmds_loadbalancer_availabilityzone_set='-h --help --description --enable --disable'
  cmds_loadbalancer_availabilityzone_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_availabilityzone_unset='-h --help --description'
  cmds_loadbalancer_availabilityzoneprofile='create delete list set show'
  cmds_loadbalancer_availabilityzoneprofile_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --provider --availability-zone-data'
  cmds_loadbalancer_availabilityzoneprofile_delete='-h --help'
  cmds_loadbalancer_availabilityzoneprofile_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --provider'
  cmds_loadbalancer_availabilityzoneprofile_set='-h --help --name --provider --availabilityzone-data'
  cmds_loadbalancer_availabilityzoneprofile_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --vip_address --vip_network_id --vip_port_id --vip_subnet_id --vip_qos_policy_id --enable --disable'
  cmds_loadbalancer_delete='-h --help'
  cmds_loadbalancer_failover='-h --help --wait'
  cmds_loadbalancer_flavor='create delete list set show unset'
  cmds_loadbalancer_flavor_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --flavorprofile --description --enable --disable'
  cmds_loadbalancer_flavor_delete='-h --help'
  cmds_loadbalancer_flavor_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --flavorprofile --enable --disable'
  cmds_loadbalancer_flavor_set='-h --help --name --enable --disable'
  cmds_loadbalancer_flavor_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_flavor_unset='-h --help --description'
  cmds_loadbalancer_flavorprofile='create delete list set show'
  cmds_loadbalancer_flavorprofile_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --provider --flavor-data'
  cmds_loadbalancer_flavorprofile_delete='-h --help'
  cmds_loadbalancer_flavorprofile_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --provider'
  cmds_loadbalancer_flavorprofile_set='-h --help --name --provider --flavor-data'
  cmds_loadbalancer_flavorprofile_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_healthmonitor='create delete list set show unset'
  cmds_loadbalancer_healthmonitor_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --delay --expected_codes --http_method --timeout --max_retries --url_path --type --enable --disable'
  cmds_loadbalancer_healthmonitor_delete='-h --help'
  cmds_loadbalancer_healthmonitor_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --type'
  cmds_loadbalancer_healthmonitor_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --delay --expected_codes --http_method --timeout --max_retries --url_path --enable --disable'
  cmds_loadbalancer_healthmonitor_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_healthmonitor_unset='-h --help --domain-name --expected-codes --http-method --http-version --max-retries-down --name --url-path --wait'
  cmds_loadbalancer_l7policy='create delete list set show unset'
  cmds_loadbalancer_l7policy_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --action --redirect-pool --redirect-url --redirect-prefix --redirect-http-code --position --enable --disable --wait'
  cmds_loadbalancer_l7policy_delete='-h --help --wait'
  cmds_loadbalancer_l7policy_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --listener'
  cmds_loadbalancer_l7policy_set='-h --help --name --description --action --redirect-pool --redirect-url --redirect-prefix --redirect-http-code --position --enable --disable --wait'
  cmds_loadbalancer_l7policy_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_l7policy_unset='-h --help --description --name --redirect-http-code --wait'
  cmds_loadbalancer_l7rule='create delete list set show unset'
  cmds_loadbalancer_l7rule_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --compare-type --invert --value --key --type --enable --disable --wait'
  cmds_loadbalancer_l7rule_delete='-h --help --wait'
  cmds_loadbalancer_l7rule_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_loadbalancer_l7rule_set='-h --help --compare-type --invert --value --key --type --enable --disable --wait'
  cmds_loadbalancer_l7rule_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_l7rule_unset='-h --help --invert --key --wait'
  cmds_loadbalancer_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_loadbalancer_listener='create delete list set show stats unset'
  cmds_loadbalancer_listener_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --protocol --protocol_port --connection_limit --default_pool --default_tls_container_ref --enable --disable'
  cmds_loadbalancer_listener_delete='-h --help'
  cmds_loadbalancer_listener_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --load_balancer --protocol --protocol_port'
  cmds_loadbalancer_listener_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --connection_limit --default_pool --default_tls_container_ref --enable --disable'
  cmds_loadbalancer_listener_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_listener_stats='show'
  cmds_loadbalancer_listener_stats_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_listener_unset='-h --help --name --description --connection-limit --default-pool --default-tls-container-ref --sni-container-refs --insert-headers --timeout-client-data --timeout-member-connect --timeout-member-data --timeout-tcp-inspect --client-ca-tls-container-ref --client-authentication --client-crl-container-ref --allowed-cidrs --wait'
  cmds_loadbalancer_member='create delete list set show unset'
  cmds_loadbalancer_member_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --weight --address --protocol_port --subnet_id --enable --disable'
  cmds_loadbalancer_member_delete='-h --help'
  cmds_loadbalancer_member_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --address --protocol_port --weight'
  cmds_loadbalancer_member_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --weight --enable --disable'
  cmds_loadbalancer_member_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_member_unset='-h --help --backup --monitor-address --monitor-port --name --weight --wait'
  cmds_loadbalancer_pool='create delete list set show unset'
  cmds_loadbalancer_pool_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --protocol --lb_algorithm --listener_id --loadbalancer_id --session_persistence --enable --disable'
  cmds_loadbalancer_pool_delete='-h --help'
  cmds_loadbalancer_pool_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --description --lb_algorithm --name --protocol --load_balancer'
  cmds_loadbalancer_pool_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --session_persistence --lb_algorithm --enable --disable'
  cmds_loadbalancer_pool_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_pool_unset='-h --help --name --description --ca-tls-container-ref --crl-container-ref --session-persistence --tls-container-ref --wait'
  cmds_loadbalancer_provider='capability list'
  cmds_loadbalancer_provider_capability='list'
  cmds_loadbalancer_provider_capability_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --flavor --availability-zone'
  cmds_loadbalancer_provider_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_loadbalancer_quota='defaults list reset set show unset'
  cmds_loadbalancer_quota_defaults='show'
  cmds_loadbalancer_quota_defaults_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_quota_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --project'
  cmds_loadbalancer_quota_reset='-h --help'
  cmds_loadbalancer_quota_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --healthmonitor --listener --loadbalancer --member --pool'
  cmds_loadbalancer_quota_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_quota_unset='-h --help --loadbalancer --listener --pool --member --healthmonitor'
  cmds_loadbalancer_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --enable --disable --description --name --vip_qos_policy_id'
  cmds_loadbalancer_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_stats='show'
  cmds_loadbalancer_stats_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_loadbalancer_status='show'
  cmds_loadbalancer_status_show='-h --help'
  cmds_loadbalancer_unset='-h --help --name --description --vip-qos-policy-id --wait'
  cmds_mapping='create delete list set show'
  cmds_mapping_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --rules'
  cmds_mapping_delete='-h --help'
  cmds_mapping_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_mapping_set='-h --help --rules'
  cmds_mapping_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_module='list'
  cmds_module_list='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all'
  cmds_nat='dnat gateway snat'
  cmds_nat_dnat='rule'
  cmds_nat_dnat_rule='create delete list show'
  cmds_nat_dnat_rule_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --nat-gateway-id --port-id --private-ip --internal-service-port --floating-ip-id --external-service-port --protocol'
  cmds_nat_dnat_rule_delete='-h --help'
  cmds_nat_dnat_rule_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --id --limit --project-id --nat-gateway-id --port-id --private-ip --internal-service-port --floating-ip-id --floating-ip-address --external-service-port --protocol --status --admin-state-up --created-at'
  cmds_nat_dnat_rule_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_nat_gateway='create delete list show update'
  cmds_nat_gateway_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --spec --router-id --internal-network-id'
  cmds_nat_gateway_delete='-h --help'
  cmds_nat_gateway_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --id --limit --project-id --name --spec --router-id --internal-network-id --status --admin-state-up --created-at'
  cmds_nat_gateway_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_nat_gateway_update='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --spec'
  cmds_nat_snat='rule'
  cmds_nat_snat_rule='create delete list show'
  cmds_nat_snat_rule_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --nat-gateway-id --floating-ip-id --network-id --cidr --source-type'
  cmds_nat_snat_rule_delete='-h --help'
  cmds_nat_snat_rule_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --id --limit --project-id --nat-gateway-id --network-id --cidr --source-type --floating-ip-id --floating-ip-address --status --admin-state-up --created-at'
  cmds_nat_snat_rule_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network='agent auto create delete flavor list log loggable meter onboard qos rbac segment service set show subport trunk unset'
  cmds_network_agent='add delete list remove set show'
  cmds_network_agent_add='network router'
  cmds_network_agent_add_network='-h --help --dhcp'
  cmds_network_agent_add_router='-h --help --l3'
  cmds_network_agent_delete='-h --help'
  cmds_network_agent_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --agent-type --host --network --router --long'
  cmds_network_agent_remove='network router'
  cmds_network_agent_remove_network='-h --help --dhcp'
  cmds_network_agent_remove_router='-h --help --l3'
  cmds_network_agent_set='-h --help --description --enable --disable'
  cmds_network_agent_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_auto='allocated'
  cmds_network_auto_allocated='topology'
  cmds_network_auto_allocated_topology='create delete'
  cmds_network_auto_allocated_topology_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --project-domain --check-resources --or-show'
  cmds_network_auto_allocated_topology_delete='-h --help --project --project-domain'
  cmds_network_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --share --no-share --enable --disable --project --description --mtu --project-domain --availability-zone-hint --enable-port-security --disable-port-security --external --internal --default --no-default --qos-policy --transparent-vlan --no-transparent-vlan --provider-network-type --provider-physical-network --provider-segment --dns-domain --tag --no-tag'
  cmds_network_delete='-h --help'
  cmds_network_flavor='add create delete list profile remove set show'
  cmds_network_flavor_add='profile'
  cmds_network_flavor_add_profile='-h --help'
  cmds_network_flavor_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --service-type --description --project --project-domain --enable --disable'
  cmds_network_flavor_delete='-h --help'
  cmds_network_flavor_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_network_flavor_profile='create delete list set show'
  cmds_network_flavor_profile_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --project-domain --description --enable --disable --driver --metainfo'
  cmds_network_flavor_profile_delete='-h --help'
  cmds_network_flavor_profile_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_network_flavor_profile_set='-h --help --project-domain --description --enable --disable --driver --metainfo'
  cmds_network_flavor_profile_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_flavor_remove='profile'
  cmds_network_flavor_remove_profile='-h --help'
  cmds_network_flavor_set='-h --help --description --disable --enable --name'
  cmds_network_flavor_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --external --internal --long --name --enable --disable --project --project-domain --share --no-share --status --provider-network-type --provider-physical-network --provider-segment --agent --tags --any-tags --not-tags --not-any-tags'
  cmds_network_log='create delete list set show'
  cmds_network_log_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --enable --disable --project --project-domain --event --resource-type --resource --target'
  cmds_network_log_delete='-h --help'
  cmds_network_log_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_network_log_set='-h --help --description --enable --disable --name'
  cmds_network_log_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_loggable='resources'
  cmds_network_loggable_resources='list'
  cmds_network_loggable_resources_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_network_meter='create delete list rule show'
  cmds_network_meter_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --project --project-domain --share --no-share'
  cmds_network_meter_delete='-h --help'
  cmds_network_meter_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_network_meter_rule='create delete list show'
  cmds_network_meter_rule_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --project-domain --exclude --include --ingress --egress --remote-ip-prefix'
  cmds_network_meter_rule_delete='-h --help'
  cmds_network_meter_rule_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_network_meter_rule_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_meter_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_onboard='subnets'
  cmds_network_onboard_subnets='-h --help'
  cmds_network_qos='policy rule'
  cmds_network_qos_policy='create delete list set show'
  cmds_network_qos_policy_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --share --no-share --project --project-domain --default --no-default'
  cmds_network_qos_policy_delete='-h --help'
  cmds_network_qos_policy_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --project --project-domain --share --no-share'
  cmds_network_qos_policy_set='-h --help --name --description --share --no-share --default --no-default'
  cmds_network_qos_policy_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_qos_rule='create delete list set show type'
  cmds_network_qos_rule_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --type --max-kbps --max-burst-kbits --dscp-mark --min-kbps --ingress --egress'
  cmds_network_qos_rule_delete='-h --help'
  cmds_network_qos_rule_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_network_qos_rule_set='-h --help --max-kbps --max-burst-kbits --dscp-mark --min-kbps --ingress --egress'
  cmds_network_qos_rule_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_qos_rule_type='list show'
  cmds_network_qos_rule_type_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_network_qos_rule_type_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_rbac='create delete list set show'
  cmds_network_rbac_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --type --action --target-project --target-all-projects --target-project-domain --project --project-domain'
  cmds_network_rbac_delete='-h --help'
  cmds_network_rbac_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --type --action --long'
  cmds_network_rbac_set='-h --help --target-project --target-project-domain'
  cmds_network_rbac_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_segment='create delete list range set show'
  cmds_network_segment_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --physical-network --segment --network --network-type'
  cmds_network_segment_delete='-h --help'
  cmds_network_segment_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long --network'
  cmds_network_segment_range='create delete list set show'
  cmds_network_segment_range_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --private --shared --project --project-domain --network-type --physical-network --minimum --maximum'
  cmds_network_segment_range_delete='-h --help'
  cmds_network_segment_range_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long --used --unused --available --unavailable'
  cmds_network_segment_range_set='-h --help --name --minimum --maximum'
  cmds_network_segment_range_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_segment_set='-h --help --description --name'
  cmds_network_segment_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_service='provider'
  cmds_network_service_provider='list'
  cmds_network_service_provider_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_network_set='-h --help --name --enable --disable --share --no-share --description --mtu --enable-port-security --disable-port-security --external --internal --default --no-default --qos-policy --no-qos-policy --tag --no-tag --provider-network-type --provider-physical-network --provider-segment --dns-domain'
  cmds_network_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_subport='list'
  cmds_network_subport_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --trunk'
  cmds_network_trunk='create delete list set show unset'
  cmds_network_trunk_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --parent-port --subport --enable --disable --project --project-domain'
  cmds_network_trunk_delete='-h --help'
  cmds_network_trunk_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_network_trunk_set='-h --help --name --description --subport --enable --disable'
  cmds_network_trunk_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_network_trunk_unset='-h --help --subport'
  cmds_network_unset='-h --help --tag --all-tag'
  cmds_object='create delete list save set show store unset'
  cmds_object_create='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name'
  cmds_object_delete='-h --help'
  cmds_object_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --prefix --delimiter --marker --end-marker --limit --long --all'
  cmds_object_save='-h --help --file'
  cmds_object_set='-h --help --property'
  cmds_object_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_object_store='account'
  cmds_object_store_account='set show unset'
  cmds_object_store_account_set='-h --help --property'
  cmds_object_store_account_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_object_store_account_unset='-h --help --property'
  cmds_object_unset='-h --help --property'
  cmds_obs='container object'
  cmds_obs_container='create delete list show'
  cmds_obs_container_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --storage_class'
  cmds_obs_container_delete='-h --help --recursive -r'
  cmds_obs_container_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_obs_container_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_obs_object='create delete list save show'
  cmds_obs_object_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name'
  cmds_obs_object_delete='-h --help'
  cmds_obs_object_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --prefix --delimiter --marker --end-marker --limit --long --all'
  cmds_obs_object_save='-h --help --file'
  cmds_obs_object_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_orchestration='build resource service template'
  cmds_orchestration_build='info'
  cmds_orchestration_build_info='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_orchestration_resource='type'
  cmds_orchestration_resource_type='list show'
  cmds_orchestration_resource_type_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --filter --long'
  cmds_orchestration_resource_type_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --template-type --long'
  cmds_orchestration_service='list'
  cmds_orchestration_service_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_orchestration_template='function validate version'
  cmds_orchestration_template_function='list'
  cmds_orchestration_template_function_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --with_conditions'
  cmds_orchestration_template_validate='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty -e --environment --show-nested --parameter -s --files-container --ignore-errors -t --template'
  cmds_orchestration_template_version='list'
  cmds_orchestration_template_version_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_policy='create delete list set show'
  cmds_policy_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --type'
  cmds_policy_delete='-h --help'
  cmds_policy_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_policy_set='-h --help --type --rules'
  cmds_policy_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_port='create delete list set show unset'
  cmds_port_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --network --description --device --mac-address --device-owner --vnic-type --host --dns-domain --dns-name --fixed-ip --no-fixed-ip --binding-profile --enable --disable --enable-uplink-status-propagation --disable-uplink-status-propagation --project --project-domain --extra-dhcp-option --security-group --no-security-group --qos-policy --enable-port-security --disable-port-security --allowed-address --tag --no-tag'
  cmds_port_delete='-h --help'
  cmds_port_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --device-owner --network --router --server --device-id --mac-address --long --project --project-domain --fixed-ip --tags --any-tags --not-tags --not-any-tags'
  cmds_port_set='-h --help --description --device --mac-address --device-owner --vnic-type --host --dns-domain --dns-name --enable --disable --name --fixed-ip --no-fixed-ip --binding-profile --no-binding-profile --qos-policy --security-group --no-security-group --enable-port-security --disable-port-security --allowed-address --no-allowed-address --data-plane-status --tag --no-tag'
  cmds_port_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_port_unset='-h --help --fixed-ip --binding-profile --security-group --allowed-address --qos-policy --data-plane-status --tag --all-tag'
  cmds_project='create delete list purge set show'
  cmds_project_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --domain --parent --description --enable --disable --property --or-show --tag'
  cmds_project_delete='-h --help --domain'
  cmds_project_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --domain --parent --user --my-projects --long --sort --tags --tags-any --not-tags --not-tags-any'
  cmds_project_purge='-h --help --dry-run --keep-project --auth-project --project --project-domain'
  cmds_project_set='-h --help --name --domain --description --enable --disable --property --tag --clear-tags --remove-tag'
  cmds_project_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --domain --parents --children'
  cmds_ptr='record'
  cmds_ptr_record='list set show unset'
  cmds_ptr_record_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --edit-managed --sudo-project-id'
  cmds_ptr_record_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --no-description --ttl --no-ttl --all-projects --edit-managed --sudo-project-id'
  cmds_ptr_record_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_ptr_record_unset='-h --help --all-projects --edit-managed --sudo-project-id'
  cmds_quota='list set show'
  cmds_quota_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --project --detail --compute --volume --network'
  cmds_quota_set='-h --help --class --cores --fixed-ips --injected-file-size --injected-path-size --injected-files --instances --key-pairs --properties --ram --server-groups --server-group-members --backups --backup-gigabytes --gigabytes --per-volume-gigabytes --snapshots --volumes --floating-ips --secgroup-rules --secgroups --networks --subnets --ports --routers --rbac-policies --subnetpools --volume-type'
  cmds_quota_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --class --default'
  cmds_rds='backup configuration datastore flavor instance'
  cmds_rds_backup='create delete download list'
  cmds_rds_backup_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --databases --wait --wait-interval'
  cmds_rds_backup_delete='-h --help'
  cmds_rds_backup_download='links'
  cmds_rds_backup_download_links='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_rds_backup_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --backup-id --backup-type --offset --limit --begin-time --end-time'
  cmds_rds_configuration='apply create delete list parameter set show'
  cmds_rds_configuration_apply='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --instance'
  cmds_rds_configuration_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --datastore-type --datastore-version --value'
  cmds_rds_configuration_delete='-h --help'
  cmds_rds_configuration_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_rds_configuration_parameter='list'
  cmds_rds_configuration_parameter_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_rds_configuration_set='-h --help --name --description --value'
  cmds_rds_configuration_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_rds_datastore='type version'
  cmds_rds_datastore_type='list'
  cmds_rds_datastore_type_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_rds_datastore_version='list'
  cmds_rds_datastore_version_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_rds_flavor='list'
  cmds_rds_flavor_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_rds_instance='backup create delete list restore show time'
  cmds_rds_instance_backup='policy'
  cmds_rds_instance_backup_policy='set show'
  cmds_rds_instance_backup_policy_set='-h --help --keep-days --start-time --period'
  cmds_rds_instance_backup_policy_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_rds_instance_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --size --volume-type --availability-zone --region --datastore-type --datastore-version --configuration --disk-encryption-id --port --password --router-id --network-id --security-group-id --ha-mode --charge-mode --replica-of --from-instance --backup --backup-keepdays --backup-timeframe --restore-time --wait --wait-interval'
  cmds_rds_instance_delete='-h --help --wait --wait-interval'
  cmds_rds_instance_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --id --name --type --datastore-type --router-id --network-id --offset'
  cmds_rds_instance_restore='-h --help --backup --restore-time --wait --wait-interval show'
  cmds_rds_instance_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_rds_instance_time='restore_show'
  cmds_rds_instance_time_restore_show='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_recordset='create delete list set show'
  cmds_recordset_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --records --record --type --ttl --description --all-projects --edit-managed --sudo-project-id'
  cmds_recordset_delete='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_recordset_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --type --data --ttl --description --status --action --all-projects --edit-managed --sudo-project-id'
  cmds_recordset_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --records --record --description --no-description --ttl --no-ttl --all-projects --edit-managed --sudo-project-id'
  cmds_recordset_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_region='create delete list set show'
  cmds_region_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --parent-region --description'
  cmds_region_delete='-h --help'
  cmds_region_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --parent-region'
  cmds_region_set='-h --help --parent-region --description'
  cmds_region_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_registered='limit'
  cmds_registered_limit='create delete list set show'
  cmds_registered_limit_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --region --service --default-limit'
  cmds_registered_limit_delete='-h --help'
  cmds_registered_limit_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --service --resource-name --region'
  cmds_registered_limit_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --service --resource-name --default-limit --description --region'
  cmds_registered_limit_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_request='token'
  cmds_request_token='authorize create'
  cmds_request_token_authorize='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --request-key --role'
  cmds_request_token_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --consumer-key --consumer-secret --project --domain'
  cmds_role='add assignment create delete list remove set show'
  cmds_role_add='-h --help --system --domain --project --user --group --group-domain --project-domain --user-domain --inherited --role-domain'
  cmds_role_assignment='list'
  cmds_role_assignment_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --effective --role --role-domain --names --user --user-domain --group --group-domain --domain --project --system --project-domain --inherited --auth-user --auth-project'
  cmds_role_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --domain --or-show'
  cmds_role_delete='-h --help --domain'
  cmds_role_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --domain'
  cmds_role_remove='-h --help --system --domain --project --user --group --group-domain --project-domain --user-domain --inherited --role-domain'
  cmds_role_set='-h --help --description --domain --name'
  cmds_role_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --domain'
  cmds_router='add create delete list remove set show unset'
  cmds_router_add='port subnet'
  cmds_router_add_port='-h --help'
  cmds_router_add_subnet='-h --help'
  cmds_router_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --enable --disable --distributed --centralized --ha --no-ha --description --project --project-domain --availability-zone-hint --tag --no-tag'
  cmds_router_delete='-h --help'
  cmds_router_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --enable --disable --long --project --project-domain --agent --tags --any-tags --not-tags --not-any-tags'
  cmds_router_remove='port subnet'
  cmds_router_remove_port='-h --help'
  cmds_router_remove_subnet='-h --help'
  cmds_router_set='-h --help --name --description --enable --disable --distributed --centralized --route --no-route --ha --no-ha --external-gateway --fixed-ip --enable-snat --disable-snat --qos-policy --no-qos-policy --tag --no-tag'
  cmds_router_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_router_unset='-h --help --route --external-gateway --qos-policy --tag --all-tag'
  cmds_secret='container delete get list order store update'
  cmds_secret_container='create delete get list'
  cmds_secret_container_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name -n --type --secret -s'
  cmds_secret_container_delete='-h --help'
  cmds_secret_container_get='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_secret_container_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit -l --offset -o --name -n --type -t'
  cmds_secret_delete='-h --help'
  cmds_secret_get='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --decrypt -d --payload -p --file -F --payload_content_type -t'
  cmds_secret_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit -l --offset -o --name -n --algorithm -a --bit-length -b --mode -m --secret-type -s'
  cmds_secret_order='create delete get list'
  cmds_secret_order_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name -n --algorithm -a --bit-length -b --mode -m --payload-content-type -t --expiration -x --request-type --subject-dn --source-container-ref --ca-id --profile --request-file'
  cmds_secret_order_delete='-h --help'
  cmds_secret_order_get='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_secret_order_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit -l --offset -o'
  cmds_secret_store='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name -n --secret-type -s --payload-content-type -t --payload-content-encoding -e --algorithm -a --bit-length -b --mode -m --expiration -x --payload -p --file -F'
  cmds_secret_update='-h --help'
  cmds_security='group'
  cmds_security_group='create delete list rule set show unset'
  cmds_security_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --project --project-domain --tag --no-tag'
  cmds_security_group_delete='-h --help'
  cmds_security_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --project --project-domain --tags --any-tags --not-tags --not-any-tags'
  cmds_security_group_rule='create delete list show'
  cmds_security_group_rule_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --remote-ip --remote-group --dst-port --protocol --proto --description --icmp-type --icmp-code --ingress --egress --ethertype --project --project-domain'
  cmds_security_group_rule_delete='-h --help'
  cmds_security_group_rule_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --protocol --ethertype --ingress --egress --long'
  cmds_security_group_rule_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_security_group_set='-h --help --name --description --tag --no-tag'
  cmds_security_group_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_security_group_unset='-h --help --tag --all-tag'
  cmds_server='add backup create delete dump event group image list lock migrate migrate_confirm migrate_revert pause reboot rebuild remove rescue resize resize_confirm resize_revert restore resume set shelve show ssh start stop suspend unlock unpause unrescue unset unshelve'
  cmds_server_add='fixed floating network port security volume'
  cmds_server_add_fixed='ip'
  cmds_server_add_fixed_ip='-h --help --fixed-ip-address'
  cmds_server_add_floating='ip'
  cmds_server_add_floating_ip='-h --help --fixed-ip-address'
  cmds_server_add_network='-h --help'
  cmds_server_add_port='-h --help'
  cmds_server_add_security='group'
  cmds_server_add_security_group='-h --help'
  cmds_server_add_volume='-h --help --device --enable-delete-on-termination --disable-delete-on-termination'
  cmds_server_backup='create'
  cmds_server_backup_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --type --rotate --wait'
  cmds_server_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --image --image-property --volume --flavor --security-group --key-name --property --file --user-data --description --availability-zone --host --hypervisor-hostname --boot-from-volume --block-device-mapping --nic --network --port --hint --config-drive --min --max --wait'
  cmds_server_delete='-h --help --wait'
  cmds_server_dump='create'
  cmds_server_dump_create='-h --help'
  cmds_server_event='list show'
  cmds_server_event_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_server_event_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_server_group='create delete list show'
  cmds_server_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --policy'
  cmds_server_group_delete='-h --help'
  cmds_server_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --long'
  cmds_server_group_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_server_image='create'
  cmds_server_image_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --wait'
  cmds_server_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --reservation-id --ip --ip6 --name --instance-name --status --flavor --image --host --all-projects --project --project-domain --user --user-domain --long -n --no-name-lookup --name-lookup-one-by-one --marker --limit --deleted --changes-before --changes-since --locked --unlocked'
  cmds_server_lock='-h --help --reason'
  cmds_server_migrate='-h --help --live-migration --live --host --shared-migration --block-migration --disk-overcommit --no-disk-overcommit --wait confirm revert'
  cmds_server_migrate_confirm='-h --help'
  cmds_server_migrate_revert='-h --help'
  cmds_server_pause='-h --help'
  cmds_server_reboot='-h --help --hard --soft --wait'
  cmds_server_rebuild='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --image --password --property --description --wait --key-name --key-unset'
  cmds_server_remove='fixed floating network port security volume'
  cmds_server_remove_fixed='ip'
  cmds_server_remove_fixed_ip='-h --help'
  cmds_server_remove_floating='ip'
  cmds_server_remove_floating_ip='-h --help'
  cmds_server_remove_network='-h --help'
  cmds_server_remove_port='-h --help'
  cmds_server_remove_security='group'
  cmds_server_remove_security_group='-h --help'
  cmds_server_remove_volume='-h --help'
  cmds_server_rescue='-h --help --image --password'
  cmds_server_resize='-h --help --flavor --confirm --revert --wait confirm revert'
  cmds_server_resize_confirm='-h --help'
  cmds_server_resize_revert='-h --help'
  cmds_server_restore='-h --help'
  cmds_server_resume='-h --help'
  cmds_server_set='-h --help --name --root-password --property --state --description --tag'
  cmds_server_shelve='-h --help'
  cmds_server_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --diagnostics'
  cmds_server_ssh='-h --help --login -l --port -p --identity -i --option -o -4 -6 --public --private --address-type -v'
  cmds_server_start='-h --help'
  cmds_server_stop='-h --help'
  cmds_server_suspend='-h --help'
  cmds_server_unlock='-h --help'
  cmds_server_unpause='-h --help'
  cmds_server_unrescue='-h --help'
  cmds_server_unset='-h --help --property --description --tag'
  cmds_server_unshelve='-h --help --availability-zone'
  cmds_service='create delete list provider set show'
  cmds_service_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --enable --disable'
  cmds_service_delete='-h --help'
  cmds_service_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_service_provider='create delete list set show'
  cmds_service_provider_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --auth-url --description --service-provider-url --enable --disable'
  cmds_service_provider_delete='-h --help'
  cmds_service_provider_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_service_provider_set='-h --help --auth-url --description --service-provider-url --enable --disable'
  cmds_service_provider_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_service_set='-h --help --type --name --description --enable --disable'
  cmds_service_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_sfc='flow port service'
  cmds_sfc_flow='classifier'
  cmds_sfc_flow_classifier='create delete list set show'
  cmds_sfc_flow_classifier_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --protocol --ethertype --source-port --destination-port --source-ip-prefix --destination-ip-prefix --logical-source-port --logical-destination-port --l7-parameters'
  cmds_sfc_flow_classifier_delete='-h --help'
  cmds_sfc_flow_classifier_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_sfc_flow_classifier_set='-h --help --name --description'
  cmds_sfc_flow_classifier_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_sfc_port='chain pair'
  cmds_sfc_port_chain='create delete list set show unset'
  cmds_sfc_port_chain_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --flow-classifier --chain-parameters --port-pair-group'
  cmds_sfc_port_chain_delete='-h --help'
  cmds_sfc_port_chain_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_sfc_port_chain_set='-h --help --name --description --flow-classifier --no-flow-classifier --port-pair-group --no-port-pair-group'
  cmds_sfc_port_chain_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_sfc_port_chain_unset='-h --help --flow-classifier --all-flow-classifier --port-pair-group'
  cmds_sfc_port_pair='create delete group list set show'
  cmds_sfc_port_pair_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --service-function-parameters --ingress --egress'
  cmds_sfc_port_pair_delete='-h --help'
  cmds_sfc_port_pair_group='create delete list set show unset'
  cmds_sfc_port_pair_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --port-pair --enable-tap --disable-tap --port-pair-group-parameters'
  cmds_sfc_port_pair_group_delete='-h --help'
  cmds_sfc_port_pair_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_sfc_port_pair_group_set='-h --help --name --description --port-pair --no-port-pair'
  cmds_sfc_port_pair_group_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_sfc_port_pair_group_unset='-h --help --port-pair --all-port-pair'
  cmds_sfc_port_pair_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_sfc_port_pair_set='-h --help --name --description'
  cmds_sfc_port_pair_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_sfc_service='graph'
  cmds_sfc_service_graph='create delete list set show'
  cmds_sfc_service_graph_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --branching-point'
  cmds_sfc_service_graph_delete='-h --help'
  cmds_sfc_service_graph_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_sfc_service_graph_set='-h --help --name --description'
  cmds_sfc_service_graph_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_share='access create delete list set show type unset'
  cmds_share_access='create delete list set show unset'
  cmds_share_access_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --properties --access-level'
  cmds_share_access_delete='-h --help'
  cmds_share_access_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --columns --properties'
  cmds_share_access_set='-h --help --property'
  cmds_share_access_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_share_access_unset='-h --help --property'
  cmds_share_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --snapshot-id --property --share-network --description --public --share-type --availability-zone --share-group'
  cmds_share_delete='-h --help --share-group --force'
  cmds_share_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --status --snapshot --public --share-network --share-type --share-group --host --share-server --project --project-domain --user --user-domain --all-projects --property --extra-spec --long --sort --limit --marker'
  cmds_share_set='-h --help --property --name --description --public'
  cmds_share_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_share_type='access create delete list set show unset'
  cmds_share_type_access='create delete list'
  cmds_share_type_access_create='-h --help'
  cmds_share_type_access_delete='-h --help'
  cmds_share_type_access_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_share_type_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --snapshot-support --create-share-from-snapshot-support --revert-to-snapshot-support --mount-snapshot-support --extra-specs --public'
  cmds_share_type_delete='-h --help'
  cmds_share_type_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all --extra-specs --columns'
  cmds_share_type_set='-h --help --extra-specs --public --description --name'
  cmds_share_type_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_share_type_unset='-h --help'
  cmds_share_unset='-h --help --property --name --description'
  cmds_software='config deployment'
  cmds_software_config='create delete list show'
  cmds_software_config_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --config-file --definition-file --group'
  cmds_software_config_delete='-h --help'
  cmds_software_config_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --limit --marker'
  cmds_software_config_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --config-only'
  cmds_software_deployment='create delete list metadata output show'
  cmds_software_deployment_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --input-value --action --config --signal-transport --container --timeout --server'
  cmds_software_deployment_delete='-h --help'
  cmds_software_deployment_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --server --long'
  cmds_software_deployment_metadata='show'
  cmds_software_deployment_metadata_show='-h --help'
  cmds_software_deployment_output='show'
  cmds_software_deployment_output_show='-h --help --all --long'
  cmds_software_deployment_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --long'
  cmds_stack='abandon adopt cancel check create delete environment event export failures file hook list output resource resume show snapshot suspend template update'
  cmds_stack_abandon='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --output-file'
  cmds_stack_adopt='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty -e --environment --timeout --enable-rollback --parameter --wait --adopt-file'
  cmds_stack_cancel='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --wait --no-rollback'
  cmds_stack_check='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --wait'
  cmds_stack_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty -e --environment -s --files-container --timeout --pre-create --enable-rollback --parameter --parameter-file --wait --poll --tags --dry-run -t --template'
  cmds_stack_delete='-h --help -y --yes --wait'
  cmds_stack_environment='show'
  cmds_stack_environment_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_stack_event='list show'
  cmds_stack_event_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --resource --filter --limit --marker --nested-depth --sort --follow'
  cmds_stack_event_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_stack_export='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --output-file'
  cmds_stack_failures='list'
  cmds_stack_failures_list='-h --help --long'
  cmds_stack_file='list'
  cmds_stack_file_list='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_stack_hook='clear poll'
  cmds_stack_hook_clear='-h --help --pre-create --pre-update --pre-delete'
  cmds_stack_hook_poll='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --nested-depth'
  cmds_stack_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --deleted --nested --hidden --property --tags --tag-mode --limit --marker --sort --all-projects --short --long'
  cmds_stack_output='list show'
  cmds_stack_output_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_stack_output_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all'
  cmds_stack_resource='list mark metadata show signal'
  cmds_stack_resource_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long -n --nested-depth --filter'
  cmds_stack_resource_mark='unhealthy'
  cmds_stack_resource_mark_unhealthy='-h --help --reset'
  cmds_stack_resource_metadata='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_stack_resource_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --with-attr'
  cmds_stack_resource_signal='-h --help --data --data-file'
  cmds_stack_resume='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --wait'
  cmds_stack_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --no-resolve-outputs'
  cmds_stack_snapshot='create delete list restore show'
  cmds_stack_snapshot_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name'
  cmds_stack_snapshot_delete='-h --help -y --yes'
  cmds_stack_snapshot_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_stack_snapshot_restore='-h --help'
  cmds_stack_snapshot_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_stack_suspend='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --wait'
  cmds_stack_template='show'
  cmds_stack_template_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_stack_update='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty -t --template -s --files-container -e --environment --pre-update --timeout --rollback --dry-run --show-nested --parameter --parameter-file --existing --clear-parameter --tags --wait --converge'
  cmds_subnet='create delete list pool set show unset'
  cmds_subnet_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --project-domain --subnet-pool --use-prefix-delegation --use-default-subnet-pool --prefix-length --subnet-range --dhcp --no-dhcp --dns-publish-fixed-ip --no-dns-publish-fixed-ip --gateway --ip-version --ipv6-ra-mode --ipv6-address-mode --network-segment --network --description --allocation-pool --dns-nameserver --host-route --service-type --tag --no-tag'
  cmds_subnet_delete='-h --help'
  cmds_subnet_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long --ip-version --dhcp --no-dhcp --service-type --project --project-domain --network --gateway --name --subnet-range --tags --any-tags --not-tags --not-any-tags'
  cmds_subnet_pool='create delete list set show unset'
  cmds_subnet_pool_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --pool-prefix --default-prefix-length --min-prefix-length --max-prefix-length --project --project-domain --address-scope --default --no-default --share --no-share --description --default-quota --tag --no-tag'
  cmds_subnet_pool_delete='-h --help'
  cmds_subnet_pool_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long --share --no-share --default --no-default --project --project-domain --name --address-scope --tags --any-tags --not-tags --not-any-tags'
  cmds_subnet_pool_set='-h --help --name --pool-prefix --default-prefix-length --min-prefix-length --max-prefix-length --address-scope --no-address-scope --default --no-default --description --default-quota --tag --no-tag'
  cmds_subnet_pool_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_subnet_pool_unset='-h --help --tag --all-tag'
  cmds_subnet_set='-h --help --name --dhcp --no-dhcp --dns-publish-fixed-ip --no-dns-publish-fixed-ip --gateway --network-segment --description --tag --no-tag --allocation-pool --no-allocation-pool --dns-nameserver --no-dns-nameservers --host-route --no-host-route --service-type'
  cmds_subnet_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_subnet_unset='-h --help --allocation-pool --dns-nameserver --host-route --service-type --tag --all-tag'
  cmds_tld='create delete list set show'
  cmds_tld_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --all-projects --edit-managed --sudo-project-id'
  cmds_tld_delete='-h --help --all-projects --edit-managed --sudo-project-id'
  cmds_tld_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --description --all-projects --edit-managed --sudo-project-id'
  cmds_tld_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --no-description --all-projects --edit-managed --sudo-project-id'
  cmds_tld_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_token='issue revoke'
  cmds_token_issue='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_token_revoke='-h --help'
  cmds_trust='create delete list show'
  cmds_trust_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --role --impersonate --expiration --project-domain --trustor-domain --trustee-domain'
  cmds_trust_delete='-h --help'
  cmds_trust_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_trust_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_tsigkey='create delete list set show'
  cmds_tsigkey_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --algorithm --secret --scope --resource-id --all-projects --edit-managed --sudo-project-id'
  cmds_tsigkey_delete='-h --help --all-projects --edit-managed --sudo-project-id'
  cmds_tsigkey_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --algorithm --scope --all-projects --edit-managed --sudo-project-id'
  cmds_tsigkey_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --algorithm --secret --scope --all-projects --edit-managed --sudo-project-id'
  cmds_tsigkey_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_usage='list show'
  cmds_usage_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --start --end'
  cmds_usage_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --project --start --end'
  cmds_user='create delete list password set show'
  cmds_user_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --domain --project --project-domain --password --password-prompt --email --description --enable --disable --or-show'
  cmds_user_delete='-h --help --domain'
  cmds_user_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --domain --group --project --long'
  cmds_user_password='set'
  cmds_user_password_set='-h --help --password --original-password'
  cmds_user_set='-h --help --name --domain --project --project-domain --password --password-prompt --email --description --enable --disable'
  cmds_user_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --domain'
  cmds_vbs='policy'
  cmds_vbs_policy='create delete execute link list show unlink update'
  cmds_vbs_policy_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --start_time --enable --frequency --rentention_num --remain_first_backup_of_curMonth --tag'
  cmds_vbs_policy_delete='-h --help'
  cmds_vbs_policy_execute='-h --help'
  cmds_vbs_policy_link='-h --help --volume'
  cmds_vbs_policy_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_vbs_policy_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_vbs_policy_unlink='-h --help --volume'
  cmds_vbs_policy_update='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --start_time --status --frequency --rentention_num --remain_first_backup_of_curMonth'
  cmds_versions='show'
  cmds_versions_show='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-interfaces --interface --region-name --service --status'
  cmds_volume='backup create delete host list migrate qos service set show snapshot transfer type unset'
  cmds_volume_backup='create delete list restore set show'
  cmds_volume_backup_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name --description --container --snapshot --force --incremental'
  cmds_volume_backup_delete='-h --help --force'
  cmds_volume_backup_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long --name --status --volume --marker --limit --all-projects'
  cmds_volume_backup_restore='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_volume_backup_set='-h --help --name --description --state'
  cmds_volume_backup_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_volume_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --size --type --image --snapshot --source --source-replicated --description --availability-zone --consistency-group --property --hint --bootable --non-bootable --read-only --read-write'
  cmds_volume_delete='-h --help --force --purge'
  cmds_volume_host='set'
  cmds_volume_host_set='-h --help --disable --enable'
  cmds_volume_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --project --project-domain --user --user-domain --name --status --all-projects --long --marker --limit'
  cmds_volume_migrate='-h --help --host --force-host-copy --lock-volume'
  cmds_volume_qos='associate create delete disassociate list set show unset'
  cmds_volume_qos_associate='-h --help'
  cmds_volume_qos_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --consumer --property'
  cmds_volume_qos_delete='-h --help --force'
  cmds_volume_qos_disassociate='-h --help --volume-type --all'
  cmds_volume_qos_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column'
  cmds_volume_qos_set='-h --help --property'
  cmds_volume_qos_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_volume_qos_unset='-h --help --property'
  cmds_volume_service='list set'
  cmds_volume_service_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --host --service --long'
  cmds_volume_service_set='-h --help --enable --disable --disable-reason'
  cmds_volume_set='-h --help --name --size --description --no-property --property --image-property --state --attached --detached --type --retype-policy --bootable --non-bootable --read-only --read-write'
  cmds_volume_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_volume_snapshot='create delete list set show unset'
  cmds_volume_snapshot_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --volume --description --force --property --remote-source'
  cmds_volume_snapshot_delete='-h --help --force'
  cmds_volume_snapshot_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --project --project-domain --long --marker --limit --name --status --volume'
  cmds_volume_snapshot_set='-h --help --name --description --no-property --property --state'
  cmds_volume_snapshot_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_volume_snapshot_unset='-h --help --property'
  cmds_volume_transfer='request'
  cmds_volume_transfer_request='accept create delete list show'
  cmds_volume_transfer_request_accept='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --auth-key'
  cmds_volume_transfer_request_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --name'
  cmds_volume_transfer_request_delete='-h --help'
  cmds_volume_transfer_request_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects'
  cmds_volume_transfer_request_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_volume_type='create delete list set show unset'
  cmds_volume_type_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --public --private --property --project --encryption-provider --encryption-cipher --encryption-key-size --encryption-control-location --project-domain'
  cmds_volume_type_delete='-h --help'
  cmds_volume_type_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long --default --public --private --encryption-type'
  cmds_volume_type_set='-h --help --name --description --property --project --project-domain --encryption-provider --encryption-cipher --encryption-key-size --encryption-control-location'
  cmds_volume_type_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --encryption-type'
  cmds_volume_type_unset='-h --help --property --project --project-domain --encryption-type'
  cmds_volume_unset='-h --help --property --image-property'
  cmds_vpn='endpoint ike ipsec service'
  cmds_vpn_endpoint='group'
  cmds_vpn_endpoint_group='create delete list set show'
  cmds_vpn_endpoint_group_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --type --value --project --project-domain'
  cmds_vpn_endpoint_group_delete='-h --help'
  cmds_vpn_endpoint_group_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_vpn_endpoint_group_set='-h --help --description --name'
  cmds_vpn_endpoint_group_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_vpn_ike='policy'
  cmds_vpn_ike_policy='create delete list set show'
  cmds_vpn_ike_policy_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --auth-algorithm --encryption-algorithm --phase1-negotiation-mode --ike-version --pfs --lifetime --project --project-domain'
  cmds_vpn_ike_policy_delete='-h --help'
  cmds_vpn_ike_policy_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_vpn_ike_policy_set='-h --help --description --auth-algorithm --encryption-algorithm --phase1-negotiation-mode --ike-version --pfs --lifetime --name'
  cmds_vpn_ike_policy_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_vpn_ipsec='policy site'
  cmds_vpn_ipsec_policy='create delete list set show'
  cmds_vpn_ipsec_policy_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --auth-algorithm --encapsulation-mode --encryption-algorithm --lifetime --pfs --transform-protocol --project --project-domain'
  cmds_vpn_ipsec_policy_delete='-h --help'
  cmds_vpn_ipsec_policy_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_vpn_ipsec_policy_set='-h --help --description --auth-algorithm --encapsulation-mode --encryption-algorithm --lifetime --pfs --transform-protocol --name'
  cmds_vpn_ipsec_policy_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_vpn_ipsec_site='connection'
  cmds_vpn_ipsec_site_connection='create delete list set show'
  cmds_vpn_ipsec_site_connection_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --dpd --mtu --initiator --peer-cidr --local-endpoint-group --peer-endpoint-group --enable --disable --local-id --peer-id --peer-address --psk --vpnservice --ikepolicy --ipsecpolicy --project --project-domain'
  cmds_vpn_ipsec_site_connection_delete='-h --help'
  cmds_vpn_ipsec_site_connection_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_vpn_ipsec_site_connection_set='-h --help --description --dpd --mtu --initiator --peer-cidr --local-endpoint-group --peer-endpoint-group --enable --disable --local-id --peer-id --peer-address --name'
  cmds_vpn_ipsec_site_connection_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_vpn_service='create delete list set show'
  cmds_vpn_service_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --subnet --flavor --enable --disable --router --project --project-domain'
  cmds_vpn_service_delete='-h --help'
  cmds_vpn_service_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --long'
  cmds_vpn_service_set='-h --help --description --subnet --flavor --enable --disable --name'
  cmds_vpn_service_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty'
  cmds_zone='abandon axfr blacklist create delete export import list set show transfer'
  cmds_zone_abandon='-h --help --all-projects --edit-managed --sudo-project-id'
  cmds_zone_axfr='-h --help --all-projects --edit-managed --sudo-project-id'
  cmds_zone_blacklist='create delete list set show'
  cmds_zone_blacklist_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --pattern --description --all-projects --edit-managed --sudo-project-id'
  cmds_zone_blacklist_delete='-h --help --all-projects --edit-managed --sudo-project-id'
  cmds_zone_blacklist_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --edit-managed --sudo-project-id'
  cmds_zone_blacklist_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --pattern --description --no-description --all-projects --edit-managed --sudo-project-id'
  cmds_zone_blacklist_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_zone_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --email --type --ttl --description --masters --attributes --all-projects --edit-managed --sudo-project-id'
  cmds_zone_delete='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_zone_export='create delete list show showfile'
  cmds_zone_export_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_zone_export_delete='-h --help --all-projects --edit-managed --sudo-project-id'
  cmds_zone_export_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --edit-managed --sudo-project-id'
  cmds_zone_export_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_zone_export_showfile='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_zone_import='create delete list show'
  cmds_zone_import_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_zone_import_delete='-h --help --all-projects --edit-managed --sudo-project-id'
  cmds_zone_import_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --edit-managed --sudo-project-id'
  cmds_zone_import_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_zone_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --name --email --type --ttl --description --status --all-projects --edit-managed --sudo-project-id'
  cmds_zone_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --email --ttl --description --no-description --masters --all-projects --edit-managed --sudo-project-id'
  cmds_zone_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_zone_transfer='accept request'
  cmds_zone_transfer_accept='list request show'
  cmds_zone_transfer_accept_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --edit-managed --sudo-project-id'
  cmds_zone_transfer_accept_request='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --transfer-id --key --all-projects --edit-managed --sudo-project-id'
  cmds_zone_transfer_accept_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'
  cmds_zone_transfer_request='create delete list set show'
  cmds_zone_transfer_request_create='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --target-project-id --description --all-projects --edit-managed --sudo-project-id'
  cmds_zone_transfer_request_delete='-h --help --all-projects --edit-managed --sudo-project-id'
  cmds_zone_transfer_request_list='-h --help -f --format -c --column --quote --noindent --max-width --fit-width --print-empty --sort-column --all-projects --edit-managed --sudo-project-id'
  cmds_zone_transfer_request_set='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --description --no-description --all-projects --edit-managed --sudo-project-id'
  cmds_zone_transfer_request_show='-h --help -f --format -c --column --noindent --variable --prefix --max-width --fit-width --print-empty --all-projects --edit-managed --sudo-project-id'

    dash=-;
    underscore=_;
    cmd="";
    words[0]="";
    completed="${cmds}";
    for var in "${words[@]:1}";
    do
	#echo "var \"$var\", cur \"$cur\", prev \"$prev\", mprev \"$mprev\", pprev \"$pprev\", words \"${words[@]:1}\""
 	if [ "$pprev" == "--os-cloud" ]; then
	    if [ "$mprev" == "=" ]; then _OS_CLOUD="--os-cloud=$var"; else _OS_CLOUD="--os-cloud $mprev"; fi
	fi
        if [[ ${var} == -* ]] || [ "${var}" == "=" ]; then
	    #echo "${words[*]}"
            #break;
	    pprev="$mprev"
	    mprev="$var"
            continue;
	fi
        if [[ ${mprev} == -* ]] || [ "$mprev" == "=" ]; then
	    pprev="$mprev"
	    mprev="$var"
            continue;
	fi

       	if [ "$prev" == "show" -o "$prev" == "delete" ]; then
		#_openstack_list "$mprev" "$cur"
		_openstack_list "$var" "$cur"
		#completed="$_ANS"
		return 0
		#break
	fi
	case "$prev" in
		--network|--subnet|--image|--port|--project|--flavor|--volume|--security-group)
		local _SRV="${prev#--}"; _SRV="${_SRV/-/ }"
		_openstack_list "$_SRV" "$cur"
		return
		;;
		--availability-zone)
		_openstack_list "availability zone" "$cur" "Zone Name"
		return
		;;
		--key-name)
		_openstack_list "keypair" "$cur"
		return
		;;
	esac

	if [ -z "${cmd}" ]; then
            proposed="${var}";
        else
            proposed="${cmd}_${var}";
        fi;
        local i="cmds_${proposed}";
        i=${i//$dash/$underscore};
        local comp="${!i}";
        if [ -z "${comp}" ]; then
            break;
        fi;
        if [[ ${comp} == -* ]]; then
            if [[ ${cur} != -* ]]; then
                completed="";
                break;
            fi;
        fi;
        cmd="${proposed}";
        completed="${comp}";
	pprev="$mprev"; mprev="$var"
    done;
    if [ -z "${completed}" ]; then
        COMPREPLY=($( compgen -f -- "$cur" ) $( compgen -d -- "$cur" ));
    else
        COMPREPLY=($(compgen -W "${completed}" -- ${cur}));
    fi;
    return 0
}

_collect_clouds()
{
	if test ! -e "$1"; then return; fi
	unset cprev indent
	OLDIFS="$IFS"
	while IFS= read line; do
		LNI="$(echo $line | sed 's/^ *//')"
		if test "${LNI:0:1}" == "#"; then continue; fi
		ind=$((${#line}-${#LNI}))
		#echo "indent $ind: \"$LNI\" \"$line\""
		if test "$cprev" == "1"; then
			indent=$ind
			#echo "Indent $indent"
			clouds="$clouds${LNI%:*} "
			#echo "${LNI%:*}"
		elif test -n "$indent"; then
			if test "$indent" == "$ind"; then
				clouds="$clouds${LNI%:*} "
				#echo "${LNI%:*}"
			fi
		fi
		if test "$line" = "clouds:"; then
			cprev=1
			#echo "clouds: found"
		else
			unset cprev
		fi
	done < "$1"
	IFS="$OLDIFS"
}

_collect_all_clouds()
{
	_collect_clouds /etc/openstack/clouds.yaml
	_collect_clouds ~/.config/openstack/clouds.yaml
	#_collect_clouds ~/clouds.yaml
	_collect_clouds clouds.yaml
}

_list_clouds()
{
	local clouds=""
	local cur prev pprev cld clds=""
	#echo $clouds
	cur="${COMP_WORDS[COMP_CWORD]}"
	prev="${COMP_WORDS[COMP_CWORD-1]}"
	pprev="${COMP_WORDS[COMP_CWORD-2]}"
	#echo "$clds"
	#echo "\"$cur\" \"$prev\" \"$pprev\""
	if [[ "${cur}" == "--os-cl"* ]]; then
		_collect_all_clouds
		for cld in $clouds; do clds="${clds}--os-cloud=$cld "; done
		COMPREPLY=( $(compgen -W "${clds}" -- "${cur}") )
		#echo "${COMPREPLY[*]}"
		return 0
	fi
	#clds=""; for cld in $clouds; do clds="${clds}=$cld "; done
	if [ "${prev}" == "--os-cloud" ]; then
		_collect_all_clouds
		if test "$cur" = "="; then cur=""; fi
		COMPREPLY=( $(compgen -W "${clouds}" -- "${cur}") )
		return 0
	fi
	if [ "${pprev}" == "--os-cloud" -a "${prev}" = "=" ]; then
		_collect_all_clouds
		COMPREPLY=( $(compgen -W "${clouds}" -- "${cur}") )
		return 0
	fi
	return 1
}


_openstack_complete()
{
	local cur prev pprev
	ccur="${COMP_WORDS[COMP_CWORD]}"
	cprev="${COMP_WORDS[COMP_CWORD-1]}"
	cpprev="${COMP_WORDS[COMP_CWORD-2]}"
	if [[ "$ccur" = "-"* ]] || [ "$cprev" == "--os-cloud" ] || [ "$cpprev" == "--os-cloud" -a "$cprev" == "=" ]; then _list_clouds && return; fi
	#local grp="access acl address aggregate ca application availability baremetal bgp bgpvpn catalog coe command compute configuration consistency consumer container credential data domain ec2 endpoint extension federation firewall flavor floating group help host hypervisor identity image implied ip keypair loadbalancer limit limits mapping messaging metric network object orchestration policy port project ptr quota recordset region registered role router secret security server service sfc snapshot software stack subnet tld token trust tsigkey usage user volume vpn zone"
	_openstack
}

complete -F _openstack_complete openstack
